C THIS SUBROUTINE FINDS A VALUE FOR LAMBDA CRUDELY APPROXIMATING ZETA
C  BY TAKING AN INTIAL VALUE FOR LAMBDA (=1.0), AND GEOMETICALLY 
C  RETROGRESSING DOWN UNTIL THE UNKNOWN ARM (UNKNWN) IS LESS THAN
C  STANDARD ARM (STAND).  A CLOSER APPROXIMATION IS THEN EVALUATED BY
C  SUBR. ROOT. 
C
C  WE NEED TO DECIDE WHETHER TO MULTIPLY BY THE  GEOMETRIC FACTOR, GFACTR,
C OR BY ITS INVERSE: WHETHER TO INCREASE LAMBDA OR DECREASE LAMBDA TO 
C CLOSE IN ON ZERO.
C 
C     WHAT ABOUT A??
C
      SUBROUTINE GEOM(FX,QNEW,UNKNW1,UNKNW2,M,A,N,LAMBDA,LAM2,
     &       ZETA,ZETPRV)
      INTEGER M,N,MESSAG,RTFLG,WRFLG
      REAL A,LAMBDA,ZETA,EPSILN,ABSZ1,ABSZ2,FX,QNEW,PREC,UNKNW1,
     &     UNKNW2,GFACTR,QINTGL,ZETPRV,LAM2,DUMMY
      DATA ABSZ1,ABSZ2 /2*0.0/
C      WRFLG=MOD(N,50)
C      IF ((WRFLG .EQ. 0) .OR. (N .GT. M-10) .OR. (N .LT. 15)) THEN
C      IF ((N .EQ. M-10) .OR. (N .EQ. 100 .AND. N.LT.M) .OR. (N .EQ. 50)
C     &      .OR. (N .EQ. 10) .OR. (N .EQ. 3)) THEN
C      	WRFLG=1
C      ELSE
C      	WRFLG=0
C      END IF
C      IF (WRFLG) THEN
C      	WRITE(8,8000)
C        WRITE(8,8005)N-1,M,A
C      END IF
C INITIALIZE LAMBDA
C CHECK FOR WHETHER SUBTRACTION OCCURS BEFORE OR AFTER THIS SUBROUTINE.
      RTFLG=0
      EPSILN=2.0E-07
      IF (N .EQ. M) THEN
        LAMBDA=1.0
        GFACTR=2.0/3.0
      ELSE
        IF (N .EQ. M-1) THEN
          LAMBDA=2.0*ZETA
          GFACTR=2.0/3.0
        ELSE
C CAN ZETA OR ZETPRV = 0.0 FOR N <M-2 ?
C !!! MUST INCLUDE ZETPRV HERE:
      	  IF (ZETA .LT. EPSILN .OR. ZETPRV .LT. EPSILN) THEN
      	    GFACTR=1.001
      	  ELSE
      	    LAMBDA=ZETA*ZETA/ZETPRV
            GFACTR=MAX(ZETA/ZETPRV,ZETPRV/ZETA,1.001)
          END IF
        END IF
      END IF
      UNKNW2=UNKNW1
      DO 110 I=1,2
        CALL SOLVE(FX,QNEW,LAMBDA,QINTGL,UNKNW1,
     &            M,A,N,DUMMY,ZETA,RTFLG,0.0)
C      IF (WRFLG) WRITE(8,8010)I,LAMBDA,UNKNW1
C      WRITE(8,8010)I,LAMBDA,UNKNW1
C        IF (UNKNW1 .LT. 0.0) THEN
        IF (I .EQ. 1) THEN
      	  LAM2=LAMBDA
          LAMBDA=LAMBDA*GFACTR
          UNKNW2=UNKNW1
        END IF      	  
C        ELSE
C          RETURN
C        END IF
110   CONTINUE
      IF (UNKNW1*UNKNW2 .LT. 0.0) RETURN
      IF ( ABS(UNKNW2) .LT. ABS(UNKNW1) ) THEN
      	GFACTR=1.0/GFACTR
        LAMBDA=LAM2*GFACTR
      ELSE
      	LAM2=LAMBDA
        LAMBDA=LAMBDA*GFACTR
        UNKNW2=UNKNW1
      END IF      	  
100   CONTINUE
        CALL SOLVE(FX,QNEW,LAMBDA,QINTGL,UNKNW1,
     &             M,A,N,DUMMY,ZETA,RTFLG,0.0)
C
C        IF (WRFLG) WRITE(8,8010)I,LAMBDA,UNKNW1
C        WRITE(8,8010)I,LAMBDA,UNKNW1
        IF (LAMBDA .LT. EPSILN) RETURN
        I=I+1
      IF (UNKNW1*UNKNW2 .GT. 0.0) THEN
        LAM2=LAMBDA
        LAMBDA=LAMBDA*GFACTR
        UNKNW2=UNKNW1
        GO TO 100
      END IF
      RETURN
8000	FORMAT(' '/'   ---GEOM STARTS---'/)
8005	FORMAT('  N = ',I6,'  M = ',I6,'  A = ',F8.3/)
8010	FORMAT(' ',I6,2F20.10)
      END
C
C
C------------------------------------------------------------------------------
