C SUBR. LROOT CALCULATES THE ROOT OF R
C
C
      SUBROUTINE LROOT(FX,QNEW,UNKNW1,UNKNW2,M,A,N,LCURR,L2,
     &                 ZETA,ZETPRV)
      INTEGER M,N,RTFLG,WRFLG
      REAL A,L1,ZETA,L2,FX,QNEW,ZETPRV,UNKNW1,UNKNW2,UNKNW3,
     &     LDIFF,EPSLN,EPSLN2,UNKNWN,LCURR,LPAST,QINTGL,DUMMY,
     &      UDIFF,MUDIFF,L12D
C      WRFLG=MOD(N,50)
C      IF ((WRFLG .EQ. 0) .OR. (N .GT. M-10) .OR. (N .LT. 15)) THEN
      IF ((N .EQ. M-10) .OR. (N .EQ. 100 .AND. N.LT.M) .OR. (N .EQ. 50)
     &      .OR. (N .EQ. 10) .OR. (N .EQ. 3)) THEN
      	WRFLG=1
      ELSE
      	WRFLG=0
      END IF
C      IF (WRFLG) WRITE(8,8000)
C      WRITE(8,8000)
      RTFLG=0
      EPSLN=1.0E-06
      L1=LCURR
      DO 100 I=1,100
      UDIFF = UNKNW1-UNKNW2
      MUDIFF = UDIFF*1.0E7
      IF (ABS(MUDIFF).LE.ABS(UNKNW1)) THEN
      LCURR=L1-1.0E-09
      ELSE
      LCURR=L1+UNKNW1*(L2-L1)/(UNKNW1-UNKNW2)
      ENDIF
      IF (ABS(UNKNW1) .LT. ABS(UNKNW2)) THEN
        LPAST=L1
      ELSE
        LPAST=L2
      END IF
      LDIFF=ABS(LCURR-LPAST)
      EPSLN2=EPSLN*LCURR
C      EPSLN2=1.0E-10
      IF (LDIFF .LT. EPSLN2) THEN
      	UNKNW1=UNKNW3
        RETURN
      END IF
      LPAST=LCURR
      CALL SOLVE(FX,QNEW,LCURR,QINTGL,UNKNW3,M,A,N,DUMMY,ZETA,
     &           RTFLG,0.0)
C      IF (WRFLG) WRITE(8,8010)I,LCURR,UNKNW3
C      WRITE(8,8010)I,LCURR,UNKNW3
      IF (UNKNW3 .GT. 0.0) THEN
        UNKNW1=UNKNW3
        L1=LCURR        
      ELSE
        UNKNW2=UNKNW3
        L2=LCURR        
      END IF
100   CONTINUE
C
C Perhaps convert to PRINT *, .  Can PRINT be formatted?
      WRITE(6,150)
      WRITE(6,2000)M,N,A,LCURR,EPSLN2
      UNKNW1=UNKNW3
      RETURN
150     FORMAT(' NO ANSWER FOUND AFTER 100 REPETITIONS')
2000	FORMAT('   M = ',I10,'  N = ',I10/3X,'A = ',F10.3,'  LAMBDA = ',
     &         F15.10,F15.10)
8000	FORMAT(' '/'   ---LROOT STARTS---')
8010	FORMAT(' ',I6,2F20.10)
      END
C
C
C------------------------------------------------------------------------------
