      SUBROUTINE INIT(NCNT,MAX,LNVAL,M,A,MSTOP,EPS,ZETA,ZETPRV,N,
     &                CONTIN,ILIM)
      INTEGER NCNT,MAX,LNVAL(10),M,MSTOP,N,CONTIN,ILIM
      REAL A,EPS(3),ZETA,ZETPRV,MINUTE,KN(2:10000)
C KNTABL.DAT contains the data for KN(2:10000), which is READ in.
C Held in COMMON with REAL FUNCTION QNEW
      COMMON /KNTABL/ KN
      OPEN(UNIT=3,FILE='GRIDFILE',STATUS='NEW')
      OPEN(UNIT=4,FILE='OLDGRDFILE',STATUS='OLD',READONLY)
      OPEN(UNIT=6,FILE='OUTFILE',STATUS='NEW')
C      OPEN(UNIT=7,FILE='GRIDFILE',STATUS='NEW')
      OPEN(UNIT=8,FILE='ROOTFILE',STATUS='NEW')
C KNTABL.DAT contains the data for array KN(2:10000)
      OPEN(UNIT=9,FILE='KNTABL.DAT',STATUS='OLD',READONLY)
C
C Set up table of values for KN(I) by inputting from datafile.
      	READ(9,*)(KN(I),I=2,10000)
C
C As in subr. LRANGE:
      MAX=10
C
      READ *, M,A,MSTOP,CONTIN
      READ *, LNVAL
      READ *, EPS
      WRITE(6,*) 'LNVAL = ',LNVAL
      WRITE(6,*) 'EPS = ',EPS
      WRITE(6,*)
      WRITE(6,1000) M,A
      WRITE(6,2000)
C      WRITE(7,*) '          LNVAL = ',LNVAL
C      WRITE(7,*) '          EPS = ',EPS
      NCNT=0
      DO 10 I=1,MAX
      	NCNT=NCNT+LNVAL(I)
10    CONTINUE
      NCNT=NCNT+1
      N=M-1
      ZETA=0.0
      ZETPRV=0.0
C
C JPI is a SYSTEM routine to interface with the VAX DCL GET$JPI routines
C Here, the 'CPULIM' keyword selects the JPI function to calculate the
C CPU time limit (in centiseconds!) for the particular batch queue to
C which the job has  been submitted. 
      IS=JPI('CPULIM',ILIM)
      IF (.NOT. IS) CALL EXIT(IS)
C The limit used for this program is 2 minutes before the queue time 
C limit, unless the job is submitted to the small queue (which currently
C has a limit of 120 seconds, or 120*100 centiseconds). This is tested 
C for. The decrement from the limit is calculated as follows:
C   (MINUTE minutes) * (60 seconds/minute) * (100 centiseconds/second)
      IF (ILIM .LT. (2+1)*60*100) THEN
      	MINUTE=0.4
      ELSE
      	MINUTE=2.0
      END IF
      PRINT *,' QUEUE LIMIT   = ',ILIM,'  centiseconds'
      ILIM=ILIM-INT(MINUTE*60.0*100.0)
      PRINT *,' PROGRAM LIMIT = ',ILIM,'  centiseconds'
      RETURN
1000	FORMAT(' ',5X,'M = ',I5,10X,'A = ',F6.4//)
2000	FORMAT(' ',5X,'N',5X,'ZETA(N)',3X,39('-'),'Ratio of ZETA:
     &WHITTLE',38('-')/)
      END
