C Called by SUBROUTINEs LGRID, LROOT, GEOM.
C CALLS SUBROUTINEs ZRANGE, TCASES, TROOT, DIVROM, and
C 	FUNCTION QNEW.
C
      SUBROUTINE SOLVE(FX,QNEW,LAMBDA,SOLUTN,UNKNW1,
     &                 M,A,N,OLDL,ZETA,RTFLG,INTPRV)
      INTEGER POSFLG,NVAL(6),MAX,NCOUNT,N,MESSAG,RTFLG,M,NOVAL,
     &        DIVFLG,NROOTS,NFRMLA
      REAL*4 A,LAMBDA,LOWLIM,UPLIM,FX,QNEW,LIM(0:6),SOLUTN,SOLN,
     &     UNKNW1,OLDL,ZETA,EPS(3),INTPRV,T1,T2,PREC
      REAL*8 DDELTA
C In COMMON with main PROGRAM QBANDIT. (?--INIT?)
      COMMON /PRECN/ EPS
C In COMMON with SUBROUTINE QSIGNS.
      COMMON /SLVQSN/ T1,T2,NROOTS
C In COMMON with FUNCTION FX
      COMMON /SLVFX/ ZETA2
      DATA POSFLG,NVAL,MAX,NCOUNT,DIVFLG /10*0/
      DATA LIM /7*0.0/
      ZETA2=ZETA
      SOLUTN=0.0
      CALL ZRANGE(LAMBDA,MAX,LIM,NVAL,M,A,N,OLDL,ZETA,RTFLG)
      	CALL TCASES(N,LAMBDA,ZETA,DDELTA,NROOTS,NFRMLA)
      	CALL TROOT(N,ZETA,LAMBDA,DDELTA,NROOTS,NFRMLA,T1,T2)
      WRITE(6,9010) LAMBDA,N,RTFLG,T1,T2,INTPRV
      DO 100 J=1,MAX
      	SOLN=0.0
      	DIVFLG=0
      	NOVAL=NVAL(J)
      	IF (NOVAL .EQ. 0) GOTO 100
      	IF (N .LT. 21) NOVAL=3		      ! Hi precision for N <= 20
      	IF (RTFLG .EQ. 0) THEN
C Root-finding
      	  PREC=EPS(NOVAL)*LAMBDA
      	ELSE IF (RTFLG .EQ. 1) THEN
C Coarse grid-forming
      	  PREC=EPS(NOVAL)*INTPRV
      	ELSE
C Root flag not equal to 0 or 1: impossible.
      	  PRINT *,'SOLVE: Root-flag (must = 0 or 1) = ',RTFLG
          STOP 'Error in SOLVE.'
      	END IF
C      WRITE(6,9000) J,DIVFLG,LIM(J-1),LIM(J)
        CALL DIVROM(FX,LIM(J-1),LIM(J),SOLN,PREC,A,N,LAMBDA,
     &              NROOTS,T1,T2,DIVFLG)
C        WRITE(6,*) 'SOLVE: SOLN (FROM ROMBERG, ONE SECTION) = ',SOLN
	SOLUTN=SOLUTN+SOLN
100   CONTINUE
C      WRITE(6,*) 'SOLVE: SOLUTN (FROM ROMBERG, SUM OF ALL SECTIONS) = ', 
C     &           SOLUTN
999   UNKNW1=QNEW(LAMBDA,SOLUTN,A,N)
C      WRITE(6,*)'QNEW + LAMBDA = ',UNKNW1+LAMBDA 
      RETURN
9000	FORMAT(' SOLVE:  J = ',I4,' DIVFLG = ',I4,' LIMITS = ',2(G16.7))
9010	FORMAT(' SOLVE: LAMBDA = ',G15.7,'  N = ',I4,' RTFLG = ',I4,
     &   ' T1 = ',G15.7,' T2 = ',G15.7,'   INTPRV = ',G15.7)
      END
C
C
C---------------------------------------------------------------------
