C Called from SUBROUTINE SOLVE only.
C Calls no subprograms.
C
      SUBROUTINE TCASES(N,LAMBDA,ZETA,DDELTA,NROOTS,NFRMLA)
      IMPLICIT REAL*8 (D)
      INTEGER N,NROOTS,NFRMLA
      REAL*4 LAMBDA,ZETA
      PARAMETER D1=1.0D0
      PARAMETER DEPS=0.00000001D0    ! 1.0E-08
      DN=DBLE(N)
      DLAMB=DBLE(LAMBDA)
      DZETA=DBLE(ZETA)
      DDELTA=D1-(DN+D1)*DZETA*DZETA
C Some precautions against undefined values.
C      IF (DDELTA .LT. 0.0D0) PRINT *,'TCASES: DDELTA < 0. imag. sqrt.'
C     & ,'DDELTA = ,',DDELTA
C      IF (ABS(DDELTA) .LT. 1.0D-20) PRINT *, 'TCASES: DDELTA small. 
C     & DDELTA = ',DDELTA,'  Danger of underflow.'
C      IF (ABS(DLAMB) .LT. 1.0D-20) PRINT *, 'TCASES: DLAMB small. 
C     & Danger of underflow. DLAMB = ',DLAMB
C
      IF (DDELTA .GE. 1.0D-07) THEN
      	NROOTS=1
      	IF (ABS(DLAMB) .GE. 1.0D-10) THEN
      		NFRMLA=1         ! case (a)
      	ELSE
      		NFRMLA=2         ! case (b)
      	END IF
      ELSE IF (DDELTA .GE. -1.0D-07) THEN
      	IF (DLAMB .GT. 1.0D-04) THEN
      		NROOTS=1         ! case (d)
      		NFRMLA=3
      	ELSE
      		NROOTS=0         ! case (c)
      	END IF
      ELSE IF (DLAMB .LT. 1.0D-10) THEN
      		NROOTS=0         ! case (g)
      ELSE
      	DCRIT=-DN*(DN+D1)*DLAMB*DLAMB*(D1-1.0D-06)/(DN-D1)
C FOR TESTING ONLY:
C      PRINT *,' '
C      PRINT *,' DCRIT = ',DCRIT
C
      	IF (DDELTA .GT. DCRIT) THEN
      		NROOTS=2         ! case (f)
      		NFRMLA=4
      	ELSE
      		NROOTS=0         ! case (e)
      	END IF
      END IF
C
C To prevent negative square root in TROOT Line 23 in calculation of 
C   GN. If true, then no real roots. Not in John's notes. case (h)
      DCASEH=(DN+D1)*DLAMB*DLAMB+DDELTA*(DN-D1)/DN
      IF (DCASEH .LT. DEPS) THEN 
      	NROOTS=0   ! case (h)
      END IF
      RETURN
      END
