C Called from SUBROUTINE SOLVE only.
C Calls no subprograms.
C
      SUBROUTINE TCASES(N,LAMBDA,ZETA,DDELTA,NROOTS,NFRMLA)
C      IMPLICIT REAL*8 (D)
      INTEGER N,NROOTS,NFRMLA
      REAL*4 LAMBDA,ZETA
      REAL*8 DN,DLAMB,DZETA,DDELTA,DCRIT
      PARAMETER D1=1.0D0
      DN=DBLE(N)
      DLAMB=DBLE(LAMBDA)
      DZETA=DBLE(ZETA)
      DDELTA=D1-(DN+D1)*DZETA*DZETA
C Some precautions against undefined values.
C      IF (DDELTA .LT. 0.0D0) PRINT *,'TCASES: DDELTA < 0. imag. sqrt.'
C     & ,'DDELTA = ,',DDELTA
C      IF (ABS(DDELTA) .LT. 1.0D-20) PRINT *, 'TCASES: DDELTA small. 
C     & DDELTA = ',DDELTA,'  Danger of underflow.'
C      IF (ABS(DLAMB) .LT. 1.0D-20) PRINT *, 'TCASES: DLAMB small. 
C     & Danger of underflow. DLAMB = ',DLAMB
C
      IF (DDELTA .GE. 1.0D-07) THEN
      	NROOTS=1
      	IF (ABS(DLAMB) .GE. 1.0D-10) THEN
      		NFRMLA=1         ! case (a)
          IF ((N .EQ. 98) .AND. 
     &      (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
            WRITE(6,*) 'TCASES:  CASE A'
          END IF
      	ELSE
      		NFRMLA=2         ! case (b)
          IF ((N .EQ. 98) .AND. 
     &      (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
            WRITE(6,*) 'TCASES:  CASE B'
          END IF
      	END IF
      ELSE IF (DDELTA .GE. -1.0D-07) THEN
      	IF (DLAMB .GT. 1.0D-04) THEN
      		NROOTS=1         ! case (d)
          IF ((N .EQ. 98) .AND. 
     &      (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
            WRITE(6,*) 'TCASES:  CASE D'
          END IF
      		NFRMLA=3
      	ELSE
      		NROOTS=0         ! case (c)
          IF ((N .EQ. 98) .AND. 
     &      (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
            WRITE(6,*) 'TCASES:  CASE C'
          END IF
      	END IF
      ELSE IF (DLAMB .LT. 1.0D-10) THEN
      		NROOTS=0         ! case (g)
          IF ((N .EQ. 98) .AND. 
     &      (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
            WRITE(6,*) 'TCASES:  CASE G'
          END IF
      ELSE
      	DCRIT=-DN*(DN+D1)*DLAMB*DLAMB*(D1-1.0D-06)/(DN-D1)
C FOR TESTING ONLY:
      PRINT *,' '
      PRINT *,' DCRIT = ',DCRIT
C
      	IF (DDELTA .GT. DCRIT) THEN
      		NROOTS=2         ! case (f)
      		NFRMLA=4
          IF ((N .EQ. 98) .AND. 
     &      (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
            WRITE(6,*) 'TCASES:  CASE F'
          END IF
      	ELSE
      		NROOTS=0         ! case (e)
          IF ((N .EQ. 98) .AND. 
     &      (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
            WRITE(6,*) 'TCASES:  CASE E'
          END IF
      	END IF
      END IF
      RETURN
      END
