      program ratio
      integer nfiles, head, i, unit99, unita, out, start
      parameter(nfiles = 1, head = 8, unit99 = 1, unita = 2, out = 3)
      real a100(0:nfiles), step
      integer n99, na, new99
      real zeta99, zetaa, factor, newzet
      character*15 files(2, 0:nfiles)
c-----these are actually 100 times the a values
      data a100 / 99.0,  99.5 /
      data files /	'K10000_99.ZETA', 'NEVER.USED',
     +			'K4000_995.ZETA',   'K4000_995.RATIO' /

         do 1000 i = 1, nfiles
         start = 4000
         step = 0.5

         open( unit = unit99, file = files(1, 0), status = 'old' )
         call skip(head, unit99)
         if (.not. locate(int(start * step), unit99)) stop

         open( unit = unita, file = files(1, i), status = 'old' )
         call skip(head, unita)
         if (.not. locate(start, unita)) stop

         open( unit = out, file = files(2, i), status = 'new')
         call title(a100(i), out)

         factor = 10.0 * sqrt(0.01 * (100 -  a100(i)))
         read( unit99, *) n99, zeta99
         do 500 j = start , 2, -2
            read( unita, *) na, zetaa
            write(out, '(1x, i5, 1p, 2 ( 1x, e16.8), 1x, i5)')
     +        na, na * zetaa * factor / (n99 * zeta99),
     +        100.0 / (na * (100 - a100(i))), n99

            if (j .gt. 2) then
                read( unit99, *) new99, newzet
                read( unita, *) na, zetaa
                write(out, '(1x, i5, 1p, 2 ( 1x, e16.8))')
     +            na, na * zetaa * factor
     +                / (0.25 * (n99 + new99) * (zeta99 + newzet)),
     +            100.0 / (na * (100 - a100(i)))
                n99 = new99
                zeta99 = newzet
             endif
500      continue
c------------a null value at the end
             na = 1
             zetaa = 0.0
             write(out, '(1x, i5, 1p, 2 ( 1x, e16.8))')
     +            na, zetaa, zetaa

         close(unit99)
         close(unita)
         close(out)

1000  continue
      end
c-----------------------------------------------------------
      subroutine skip(nlines, file)
      integer nlines, file, i
      do 100 i = 1, nlines
         read(file, *)
100   continue
      return
      end
c----------------------------------------------------------
      logical function locate(n, file)
      integer n, file, ok, try
100   read(file, *, iostat = ok) try
      if (ok .eq. 0) then
          if (try .eq. n) then
               backspace(file)
               locate = .true.
               return
          else
               goto 100
          endif
      else
          locate = .false.
          return
      endif
      end
c---------------------------------------------------------
      subroutine title(a100, file)
      integer  file
      real a100
      write(file,'(1x, 2a, f4.1, a)')'This file contains ratios with',
     + '	a = ', a100, ' / 100  against a = 99 / 100 = 0.99 .'
      write(file, '(1x, a)' ) 'n	= from the a file'
      write(file, '(1x, a)' ) 'ratio	= phi(a, v)/v : phi(0.99, v)/v'
      write(file, '(1x, a)' ) 'v	= 1/(n(1 - a))'
      write(file, '(1x, a)' ) 'm	= matching n from 0.99 file'
      write(file, '(/, 1x, a5, 1x, a16, 1x, a16, 1x, a5)')
     +           'n', 'ratio', 'v', 'm'
      write(file, '( 1x, a5, 1x, a16, 1x, a16, 1x, a5)')
     +           '----', '---------------',
     +           '---------------', '----'
      return 
      end
c---------------------------------------------------------
