C LGRID FORMS A COARSE GRID FOR LAMBDA. FOR EACH LAMBDA A SEPARATE 
C INTEGRATION OF QNSTAR(Z) IS REQUIRED BECAUSE THE INTEGRAND ALSO DEPENDS 
C ON LAMBDA.   IF N=M, THEN THE COARSE GRID OF (LAMBDA,Q)'S IS CALCULATED
C DIRECTLY, IN A SEPARTATE SUBROUTINE, MDGRID.  
C IF N<M THEN THE INTEGRATION IS PERFORMED OVER A RANGE OF Z'S (IN
C SUBROUTINE ZRANGE, CALLED FROM SUBR. SIMP) WHICH FORMS A FINE 
C GRID OF Z'S.  THESE ARE THEN USED TO CALCULATE A FINE GRID OF Q'S IN
C FUNCT. FX(NF=2) CALLED FROM SIMP; THESE ARE THEN INTEGRATED TO FORM
C QINTGL WHICH IS RETURNED TO SUBROUTINE LGRID BELOW.  FUNCTION QNEW THEN
C TRANSFORMS THIS (QINTGL) INTO QSTAR(N-1) FOR THE CURRENT VALUE OF N. 
C 
C  1. FOR N=M, WE KNOW QMSTAR(Z)=-Z/(1.0-A).  THIS IS DONE IN SUBR. MGRID.
C  2.     N<M
C
C COARSE GRID-FORMING
C
C------------------------------------------------------------------------------
C
      SUBROUTINE LGRID(FX,QNEW,LNVAL,LLIM,M,A,N,OLDL,ZETA,ZETPRV,CONTIN,
     &                 CPUFLG)
      INTEGER LNVAL(10),ZNVAL(6),N1,NCOUNT,NCNT,M,N,MESSAG,RTFLG,CONTIN,
     &        MODN,CPUFLG,I,J
      LOGICAL PRTGRD
      REAL A,OLDL,ZETA,ZETPRV,FX,QINTGL,QNEW,PREC,LLIM(0:10),
     &     ZLIM(0:6),ALIM,BLIM,HINTVL,AI,AN,OLDLAM(200),OLDQ(200),
     &     NEWLAM(200),NEWQ(200),NEWL,INTPRV,REMN
      COMMON /GRD/ OLDLAM,OLDQ,NCNT
      RTFLG=1
      NCOUNT=0
      PREC=0.00000001
      INTPRV=OLDL
14000 DO 3 J=1,10
        IF (LNVAL(J) .EQ. 0) GOTO 998
        IF (N .LE. 20) THEN
      		IF (LNVAL(J) .LT. 10) LNVAL(J)=10
      	END IF
        ALIM=LLIM(J-1)
        BLIM=LLIM(J)
        AN=LNVAL(J)
        HINTVL=(ALIM-BLIM)/AN
        N1=LNVAL(J)
        DO   1   I=1,N1
          NCOUNT=NCOUNT+1
          AI=I-1
C INTEGRATION REQUIRED FOR EACH LAMBDA, I.E., OLDL, OVER ITS RANGE
C OF Z IN ORDER TO CALCULATE OLDQ FOR THE COARSE GRID.
            NEWLAM(NCOUNT)=ALIM-HINTVL*AI
            NEWL=NEWLAM(NCOUNT)
      	    CALL SOLVE(FX,QNEW,NEWL,QINTGL,NEWQ(NCOUNT),
     &                 M,A,N,OLDL,ZETA,RTFLG,INTPRV)
      	    INTPRV=NEWQ(NCOUNT)+NEWL
1       CONTINUE
3     CONTINUE
998   CONTINUE
        CALL SUBARY(OLDLAM,OLDQ,NEWLAM,NEWQ,NCOUNT)
      CALL SORT(OLDLAM,OLDQ,NCOUNT)
      NCNT=NCOUNT+1
      OLDLAM(NCNT)=OLDLAM(NCOUNT)
      OLDQ(NCNT)=OLDQ(NCOUNT)
      PRTGRD=(N .EQ. 1000) .OR. (N .EQ. 900) .OR. (N .EQ. 800)
     &       .OR. (N .EQ. 700) .OR. (N .EQ. 600) .OR. (N .EQ. 500) 
     &       .OR. (N .EQ. 400) .OR. (N .EQ. 300) .OR. (N .EQ. 200) 
     &       .OR. (N .EQ. 100) .OR. (N .EQ. 90) .OR. (N .EQ. 80)
     &       .OR. (N .EQ. 70) .OR. (N .EQ. 60) .OR. (N .EQ. 50)
     &       .OR. (N .EQ. 40) .OR. (N .EQ. 30) .OR. (N .EQ. 20)
     &       .OR. (N .EQ. 10) .OR. (N .EQ. 9) .OR. (N .EQ. 8)
     &       .OR. (N .EQ. 7) .OR. (N .EQ. 6) .OR. (N .EQ. 5)
     &       .OR. (N .EQ. 4) .OR. (N .EQ. 3) .OR. (N .EQ. 2)
     &       .OR. (N .EQ. 1)
      IF ((CPUFLG .NE. 0) .OR. (PRTGRD)) THEN
     	WRITE(3,*) N,OLDL,ZETA
        WRITE(3,1000)((OLDLAM(I),OLDQ(I)),I=1,NCNT)
        PRINT *, 'N,OLDL,ZETA: ',N,OLDL,ZETA
        PRINT *, 'GRID PRINTED FOR END OF PART OF RUN'
      END IF
      RETURN
1000    FORMAT(' ',40(/2E16.8))
1030    FORMAT('  ',50('-'))
      END
