C Sets range: no. of intervals and limits for each range of Z, for A 
C given LAMBDA.
C
      SUBROUTINE ZRANGE(LAMBDA,MAX,ZLIM,ZNVAL,
     &     M,A,N,OLDL,ZETA,RTFLG)
      INTEGER INTVL(6,3),ZNVAL(6),M,N,MAX,RTFLG,PRECIS(6,3)
      REAL A,DUMLAM,OLDL,ZETA,FOCUS,ZLIM(0:6),LAMBDA,X,AN,RTNM1,
     &     NP1,INCRMT(4)
C      DATA IRANG /-6,-4,-2,2,4,6/
      DATA PRECIS /3,3,3,3,3,3,
     & 		   2,2,2,2,2,2,
     & 	 	   1,1,1,1,1,1/
      DATA INCRMT /5.0,15.0,50.0,200.0/
C      DATA INCRMT /1.5,5.0,10.0,15.0,25.0,50.0,
C     &             100.0,200.0,400.0,800.0/
      AN=FLOAT(N)
      AN3=AN*AN*AN
      NP1=AN+1.0
      RTNM1=SQRT(AN-1.0)
      IF (N .GT. 5) THEN
      	MAX=3
      ELSE
      	MAX=4
      END IF
C      MAX=6
C
C Find precision required for given LAMBDA.
C
C RTFLG, root flag, shows whether root-finding (=0; called from GEOM or 
C LROOT) or coarse grid-forming (=1; called from LGRID) is being done. 
C
      IF (RTFLG .EQ. 0) THEN
        J1=1
      ELSE IF (LAMBDA .GT. OLDL) THEN
        WRITE(6,*)'LAMBDA > OLDL IN ZRANGE: WHY???'
        WRITE(6,*)' N = ',N,'LAMBDA = ',LAMBDA,'OLDL = ',OLDL
      ELSE IF (LAMBDA .GT. OLDL-2.0/RTNM1) THEN
        J1=1
      ELSE IF (LAMBDA .GT. OLDL-3.0/RTNM1) THEN
        J1=2
      ELSE
        J1=3
      END IF
      DO 10 I=1,MAX
        ZNVAL(I)=PRECIS(I,J1)
10    CONTINUE
C
C  2. Find range of intervals: the limits to the intervals for given LAMBDA
C
C  Sets limits
C
      ZLIM(0)=0.0      !Integration is from 0 in the unknown var. case
      DO 20 I=1,MAX
          ZLIM(I)=2.0*REAL(I)*(1.0+4.0*INCRMT(I)/AN3)
20    CONTINUE
      RETURN
      END
